/**
 * @file
 * Bak image style broken since blazy:2.0 which removed custom breakpoints.
 */

(function ($, Drupal, _) {

  'use strict';

  Drupal.gridstack = Drupal.gridstack || {};

  /**
   * The GridStack image.
   */
  Drupal.gridstack.image = {

    prepareImageStyle: function () {
      // @todo no longer works since blazy removed its custom breakpoints.
      // @todo if (!me.isNested) {
      // @todo   me.$el.on('change.gsimg', '.form-select--image-style', _.bind(me.onChangeImageStyle, me));
      // @todo   me.$el.on('click.gsimg', '.form-select--image-style', _.bind(me.onClickImageStyle, me));
      // @todo   $('.form-select--image-style', me.$el).each(_.bind(me.populateImageStyle, me));
      // @todo }
    },

    populateImageStyle: function (i, el) {
      var $el = $(el);
      var $box = $el.closest('.box');
      var v = $box.data('imageStyle');
      var $selected = '<option value="' + v + '">' + v + '</option>';

      if (v && v !== '' && !$el.children().length) {
        $el.html($selected);
      }
    },

    onChangeImageStyle: function (e) {
      var me = this;
      var $el = $(e.currentTarget);
      var $box = $el.closest('.box');
      var i = $box.index();
      var box = me.collection.at(i);
      var stored = me.getStoredImageStyle(i);
      var v = $el.val() || stored || $box.data('imageStyle');

      $el.val(v).attr('data-imageid', v);
      $el.find('option:selected').prop('selected', true).siblings('option').prop('selected', false);

      // Pass it to Backbone model.
      if (me.isValidModel(box)) {
        box.set('image_style', v);
      }

      if (me.isRendered) {
        me.collection.trigger('change', box);
      }
    },

    onClickImageStyle: function (e) {
      var $el = $(e.currentTarget);
      var $box = $el.closest('.box');
      var v = $box.data('imageStyle');

      if ($el.children().length < 2) {
        $el.html(this.imageStyleOptions());

        if (v !== '') {
          $el.val(v).attr('data-imageid', v);
        }
      }
    },

    imageStyleOptions: function () {
      var img = $('#gridstack-image-style-template').html();
      var clone = $(img).clone().removeAttr('id');

      return clone[0].innerHTML;
    },

    getStoredImageStyle: function (i) {
      var me = this;
      if (me.isValid(me.nodes[i])) {
        var node = _.values(me.nodes[i]);
        return _.isUndefined(node[4]) ? '' : node[4];
      }
      return '';
    }

  };

})(jQuery, Drupal, _);
